<%

//////////////////////////////////////////////////////////////////////
//   misc. strings:
//////////////////////////////////////////////////////////////////////

var current_script= String(Request.ServerVariables("SCRIPT_NAME"));

out = "";

basic_ship_cost = 1.95
two_day_ship_cost = 6.95
one_day_ship_cost = 8.95


array_of_states = new Array("CA","PA","NV")

//////////////////////////////////////////////////////////////////////
//   script mapping
//////////////////////////////////////////////////////////////////////

display_records_script = "cart_list_items_for_sale.asp"

cart_set_session_script = "cart_set_session.asp"
cart_view_contents_script = "cart_view_contents.asp"

change_qty_script = "cart_change_qty.asp"
cart_remove_all_from_cart_script = "cart_remove_all.asp"
//clear_session_script = "cart_clear_session.asp"

collect_shipping_information_script = "collect_shipping_information.asp"
set_shipping_info_script = "set_shipping_information.asp"
collect_billing_info_script = "collect_billing_information.asp"
set_cc_billing_information_script = "set_cc_billing_information.asp"
set_pwc_billing_information_script = "set_pwc_billing_information.asp"

order_complete_script = "order_complete.asp"

view_session_info_script = "view_session_contents.asp"


//////////////////////////////////////////////////////////////////////
//   Stuff relating to displaying items for sale
//////////////////////////////////////////////////////////////////////

var catalog_file = "catalog_file.txt";
var option_file = "option_file.txt";

var category = String(Request("category"));
var keyword = String(Request("keyword"));

if (category != "undefined"){
var	search_term = category
var search_type = "category"
}

else if (keyword != "undefined"){
var	search_term = keyword
var search_type = "keyword"
}

else {
var search_type = "all"
}

//// create_items_object () returns an object that contains zero or more items that
//// are for sale

function create_items_object (){
var items = new Object();

// get rid of script name in absolute path
// and replace with name of file we want to open
var abs_path =  String(Request.ServerVariables("PATH_TRANSLATED"));
var file_to_open = abs_path.replace(/\\\w*\.asp/,"\\") + catalog_file;

fso = new ActiveXObject("Scripting.FileSystemObject");

if (!fso.FileExists(file_to_open)){
	Response.Write("can't open " + file_to_open)
	}
else {
	fs_stream = fso.OpenTextFile(file_to_open);

	var temp_regex = new RegExp(search_term,"i") 
	while (! fs_stream.AtEndOfStream){

		temp = fs_stream.ReadLine() ;
		temp_array = temp.split(/\|/);

		if ((search_type=="category" && temp_array[1].search(temp_regex)>=0) || (search_type=="keyword" && (temp_array[1].search(temp_regex)>=0 || temp_array[2].search(temp_regex)>=0 || temp_array[3].search(temp_regex)>=0)) || (search_type =="all" && temp_array[0] != "//id")){
			items[temp_array[0]] = new Object();
			items[temp_array[0]].category = temp_array[1];
			items[temp_array[0]].name = temp_array[2];
			items[temp_array[0]].description = temp_array[3];
			items[temp_array[0]].image = temp_array[4];
			items[temp_array[0]].options = new Object();
			items[temp_array[0]].options_qty = 0;
		}
  
	} // end while
	  	

fs_stream.close();
} // end if file opens

// open option file and grab option information

file_to_open = abs_path.replace(/\\\w*\.asp/,"\\") + option_file;

if (!fso.FileExists(file_to_open)){
	Response.Write("can't open " + file_to_open)
	}
else {
	fs_stream = fso.OpenTextFile(file_to_open);

	while (! fs_stream.AtEndOfStream){
		temp = fs_stream.ReadLine() ;
		// if there are two pipes next to each other, add a space.
		temp = temp.replace(/\|\|/g,"| |");
		temp_array = temp.split(/\|/);

		if (temp_array[0] != "//id" && String(items[temp_array[0]]) != "undefined"){

			temp_qty = items[temp_array[0]].options_qty
			items[temp_array[0]].options[temp_qty] = new Object
			if (temp_array[1] == " "){ temp_array[1] = "" }
			items[temp_array[0]].options[temp_qty].ext = temp_array[1]
			items[temp_array[0]].options[temp_qty].price = temp_array[2]
			items[temp_array[0]].options[temp_qty].weight = temp_array[3]

			if (String(temp_array[4]) == "undefined"){
				items[temp_array[0]].options[temp_qty].description = "none"
				}
			else{
				items[temp_array[0]].options[temp_qty].description = temp_array[4]
				}
			temp_buy_link = '<a href="' + cart_set_session_script + '?add='
			temp_buy_link2 = items[temp_array[0]].name + "---" + items[temp_array[0]].description
			if (items[temp_array[0]].options[temp_qty].description != "none"){
				temp_buy_link2 += " ("+ items[temp_array[0]].options[temp_qty].description +")"}
			temp_buy_link2 += "---" + temp_array[0] + temp_array[1] + "---" + temp_array[2] + "---" + temp_array[3]
			temp_buy_link += Server.URLEncode(temp_buy_link2) + '">Buy</a>';

			items[temp_array[0]].options[temp_qty].buy_link = temp_buy_link

			items[temp_array[0]].options_qty++
			//Response.Write(temp_array+ "<br>")
			}
		} // end while
	} // end else
return items
} // end defining function create_items_object ()

//////////////////////////////////////////////////////////////////////
//   Create the cart_items and order_info object
//////////////////////////////////////////////////////////////////////

// first create both objects

cart_items = new Object();
order_info = new Object();
order_info.subtotal = 0;
order_info.weight = 0;

// loop through the Session object and provision cart_items:

for (i = 1 ; i <= Session.Contents.Count ; i++){
	if ((typeof Session.Contents(i) == "object") && (Session(Session.Contents.key(i)+".qty") > 0)){
		cart_items[i-1] = new Object;
		temp_uid = Session.Contents.key(i)
		cart_items[i-1].uid = temp_uid
		cart_items[i-1].qty = parseInt(Session(temp_uid+".qty"))
		cart_items[i-1].name = Session(temp_uid+".name")
		cart_items[i-1].desc = Session(temp_uid+".desc")
		cart_items[i-1].price = parseFloat(Session(temp_uid+".price"))
		cart_items[i-1].weight = parseFloat(Session(temp_uid+".weight"))
		order_info.subtotal += cart_items[i-1].price*cart_items[i-1].qty
		order_info.weight += cart_items[i-1].weight*cart_items[i-1].qty
		}// end if

}// end for


// set order_info stuff

order_info.uid = Session("order_info.uid")

order_info.ship_type = Session("order_info.ship_type")
order_info.ship_cost = Session("order_info.ship_cost")

order_info.tax = parseFloat(Session("order_info.tax"))

order_info.f_name = Session("order_info.f_name")
order_info.l_name = Session("order_info.l_name")
order_info.email = Session("order_info.email")
order_info.phone = Session("order_info.phone")

order_info.address_1 = Session("order_info.address_1")
order_info.address_2 = Session("order_info.address_2")
order_info.city = Session("order_info.city")
order_info.state = Session("order_info.state")
order_info.zip = Session("order_info.zip")

// summary fields:
order_info.ship_address = Session("order_info.ship_address")
order_info.contact_info = Session("order_info.contact_info")
order_info.order_summary = Session("order_info.order_summary")
order_info.billing_info = Session("order_info.billing_info")


//////////////////////////////////////////////////////////////////////
// functions that build rows in the tables used to display the 
// contents of the shopping cart:
//////////////////////////////////////////////////////////////////////


//// zero or more rows that include a text box to change the qty of an item
//// and a delete link that lets shopper remove an item from cart.

function cart_contents_editable_row (){
if (order_info.subtotal == 0){
	%><tr><td colspan=6 align=center>No Items in cart</td></tr><%	}
else{
// loop throught the cart_items object and add the contents of the cart to the table
for (i in cart_items){  
	%>
	<tr>
		<td><% =  cart_items[i].uid %></td>
		<td><% = cart_items[i].name%></td>
		<td><% = cart_items[i].desc%>	(Weight Factor: <%= cart_items[i].weight %>)</td>
		<td>
			<input type=text name="uid_<%=cart_items[i].uid%>" value="<% =  cart_items[i].qty %>" size=2>
			</td>
		<td><% = dollarise(cart_items[i].price)%></td>
		<td><% = dollarise(cart_items[i].price * cart_items[i].qty)%></td>
		<td></td>
		<td>
			<a href="<%=change_qty_script%>?set_qty=0&uid=<%=cart_items[i].uid%>"><font color=red size=1>Delete This Item</font></a>
			</td>
		</tr>
	<%
		} // end looping through cart_items
	}//end else
} // end cart_contents_editable_row ()


//// a row of headers

function cart_contents_header_row(){ %>
<tr><td>p/n</td><td>name</td><td>desc</td><td>qty.</td><td>price</td><td>ext.<br>price</td></tr>	<% 
} // end cart_contents_start_table() 


//// a subtotal row

function cart_contents_subtotal_row(){ %>
<tr><td colspan=5 align=right>subtotal</td><td><% = dollarise(order_info.subtotal) %></td></tr>	<%
} // end cart_contents_subtotal_row()


//// zero or more rows that display contents of cart. not editable

function cart_contents_non_editable_row (){
if (order_info.subtotal == 0){
	%>
	<tr><td>&nbsp;</td><td>&nbsp;</td><td>No Items in cart</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td></td><td></td></tr>
	<%	}

else {
	// loop throught the cart_items object and add the contents of the cart to the table
	for (i in cart_items){  
		%>
		<tr>
			<td><% =  cart_items[i].uid %></td>
			<td><% = cart_items[i].name%></td>
			<td><% = cart_items[i].desc%>	(Weight Factor: <%= cart_items[i].weight %>)</td>
			<td><% =  cart_items[i].qty %></td>
			<td><% = dollarise(cart_items[i].price)%></td>
			<td><% = dollarise(cart_items[i].price * cart_items[i].qty)%></td>
		</tr>
	<%	} // end looping through cart_items object
	} // end else
} // function cart_contents_non_editable_row ()




//// row with shipping cost

function cart_contents_shipping_row() { 
// if ship_type is null, set it to basic:
if (order_info.ship_type == null){
	order_info.ship_type = "basic"
	order_info.ship_cost = order_info.weight*basic_ship_cost
	}
%>
<tr><td colspan=5 align=right>shipping cost</td><td><% = dollarise(order_info.weight*order_info.ship_cost) %></td></tr>
<%
} // end cart_contents_shipping_row()


//// row with amount of tax, if any

function cart_contents_tax_row() { 
	%>
	<tr><td colspan=5 align=right>tax</td><td><% = dollarise(order_info.tax) %></td></tr>
	<%
} 

//// row with grand total

function cart_contents_grand_total_row() { 
	%>
	<tr><td colspan=5 align=right>total</td><td><% = dollarise(order_info.subtotal + order_info.tax + order_info.ship_cost) %></td></tr>
	<%
} 


//////////////////////////////////////////////////////////////////////
// Misc. Functions
//////////////////////////////////////////////////////////////////////

function dollarise(temp_amount){
// interesting bug: this returns: 894.9999999999999
//temp_amount2 = String(8.95 * 100)
if (temp_amount > 0){
	temp_amount2 = String(Math.round(temp_amount * 100))
	temp_length = parseInt(temp_amount2.length)
	temp_price_1 = temp_amount2.substring(0,(temp_length-2))
	temp_price_2 = temp_amount2.substring((temp_length-2),temp_length)
	return("$"+ temp_price_1 + "." + temp_price_2)
	}
else
	return("$0.00")
} // end dollarise



//// creates a header used by some of the scripts. header includes links to a couple
//// of categories, a keyword search box, and a link to the cart page

function cart_header(){
%>
<HTML><HEAD><TITLE><% = current_script %></TITLE></HEAD><BODY BGCOLOR="#FFFFFF" >
<table border=1 width=90% align=center>
	<tr>
		<td colspan=2 align=center>View by Category</td>
		<td align=center>Keyword Search</td>
		<td align=center>View Contents of</td>
	<tr><td align=center>
		<a href="<% = display_records_script %>?category=books">books</a>
	</td><td align=center>
		<a href="<% = display_records_script %>?category=pastries">pastries</a>
	</td><td align=center>
		<form action="<% = display_records_script %>">
		Search For: <input type=text name=keyword value="">
		<input type=submit name=toss value="Go->"></form>
	</td><td align=center>
		<a href="<% =cart_view_contents_script %>">Cart</a>  

	</td></tr>
	
</table>
<hr>
<%
} // end cart_header


//// session_contents() creates a snapshot of the contents of the session object
//// which is useful for debugging.

function session_contents(){

for (i = 1 ; i <= Session.Contents.Count ; i++){
	if (typeof(Session.Contents(i)) == "object") {
//		cart_items[i-1] = new Object;
%>
		<% = i + ". " + Session.Contents.key(i) %> (<% = typeof(Session.Contents(i)) %>): 
		<% //= Session(Session.Contents.key(i))%>
<blockquote><table border=1>

<%		// loop through and find "properties" of object:
		var temp_regex = new RegExp(Session.Contents.key(i)) 
		for (ii = 1 ; ii <= Session.Contents.Count ; ii++){
			if (Session.Contents.key(ii).search(temp_regex) >= 0 && typeof(Session.Contents(ii)) != "object"){
				%>
				<tr><td>
				<% = Session.Contents.key(ii) %> (<% = typeof(Session.Contents(ii)) %>)
				</td>
				<td align=left>
				<pre><% =  Session(Session.Contents.key(ii)) %></pre>
				</td></tr>
				<%
				} // end if search good
			} //end inside for
%>
</table></blockquote>
<%

	} // end if
} // end outside for

} // end function session_contents

%>